/**
 * Bits from Italy - Arduino Remote Control System v.2.0.1
 Load this sketch onto your Arduino board to manage
 remotely your parking.
 You can use our Android App "Arduino Remote Control" to remotely
 manage your parking. Download it from Google Play
 More info on http://www.bitsfromitaly.it */
 
#include <SPI.h>
#include <Ethernet.h>
 
int pin1 = 4;
int pin2 = 5;
int pin3 = 8;
int pin4 = 9;
boolean autoin = false;
boolean autoout = false;
// Arduino Uno IP address - change it at your needs
byte ip[] = {192, 168, 1, 13};
// Arduino Mac Address - insert your own mac or keep this address
byte mac[] = {
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED
};

EthernetServer server(80);
 
void setup() {
  // Here we select the pins of Arduino we are going to use and we set them as output
  pinMode(pin1,OUTPUT);
  pinMode(pin2,OUTPUT);
  pinMode(pin3,OUTPUT);
  pinMode(pin4,OUTPUT);
  // Set the pins to LOW while Arduino starts
  digitalWrite(pin1,LOW);
  digitalWrite(pin2,LOW);
  digitalWrite(pin3,LOW);
  digitalWrite(pin4,LOW);
  Serial.begin(9600);
  // Run web server on Arduino
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
}
 
void loop() {
  
  // Let's listen for new clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    boolean currentLineIsBlank = true;
    String postText ="";
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        if(postText.length()<10){
          postText +=c;
        }
        // If HTTP request ends then webserver will send the response
        // Web page is responsive while we use CSS
        if (c == '\n' && currentLineIsBlank) {
          // Let's create the web page
          client.println(F("HTTP/1.1 200 OK"));
          client.println(F("Content-Type: text/html"));
          client.println(F("Connection: close"));
          client.println();
          client.println(F("<meta charset=UTF-8>"));
          client.println(F("<!DOCTYPE HTML>"));
          client.println(F("<html>"));
          client.println(F("<head> <meta charset=\"utf-8\"><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\"><link rel=\"stylesheet\" href=\"http://www.w3schools.com/lib/w3.css\"> </head>")); // Viene creato il Titolo
          client.println(F("<body>"));
          client.println(F("<div style=\"text-align:center;margin-top:100px;\"><img src=\"http://www.bitsfromitaly.it/images/logo_60_40.png\"><h2>Bits from Italy - Remote Control System</h2></div>")); // we take some space in case you have a menu on top of page
          client.println(F("<div class=\"w3-row w3-lime w3-padding\">"));
          client.println(F("<br>"));
          client.println(F("<div class=\"w3-half w3-indigo w3-center w3-padding w3-leftbar w3-rightbar\" style=\"min-width:400px\">"));
          client.println(F("<h1>Entrance</h1>"));
          client.println(F("<div class=\"w3-half w3-blue w3-center w3-padding\">"));
          // User has clicked Entrance "Raise barrier" button
          if(postText.indexOf("?ae") >0){
            digitalWrite(pin1,HIGH);
            delay(1000); // we wait 1 second and then release the contact
            digitalWrite(pin1,LOW);
            Serial.println("Entrance barrier up");
          }
          client.println(F("<div class=\"w3-content w3-padding\"><img src=\"http://www.bitsfromitaly.it/images/barrier.png\" onclick=\"location.href='http://192.168.1.13/?ae'\"></div>"));
          client.println(F("</div>"));
          client.println(F("<div class=\"w3-half w3-blue w3-center w3-padding\">"));
          // User has set Entrance to automatic mode
          if(postText.indexOf("?ate") >0 ){
            digitalWrite(pin2,HIGH);
            Serial.println("Entrance automatic mode");
            autoin = true;
          }
          // User has set Entrance to control access
          if(postText.indexOf("?bae") >0 ){
            digitalWrite(pin2,LOW);
            Serial.println("Entrance control access mode");
            autoin = false;
          }
          if (autoin == false)
            { client.println(F("<div class=\"w3-content w3-padding\"><img src=\"http://www.bitsfromitaly.it/images/automatic.png\" onclick=\"location.href='http://192.168.1.13/?ate'\"></div>")); }
            else
            { client.println(F("<div class=\"w3-content w3-padding\"><img src=\"http://www.bitsfromitaly.it/images/badge.png\" onclick=\"location.href='http://192.168.1.13/?bae'\"></div>")); }
          client.println(F("</div>"));
          client.println(F("</div>"));
          client.println(F("<div class=\"w3-half w3-indigo w3-center w3-padding w3-leftbar w3-rightbar\" style=\"min-width:400px\">"));
          client.println(F("<h1>Exit</h1>"));
          client.println(F("<div class=\"w3-half w3-blue w3-center w3-padding\">"));
          // User has clicked Exit "Raise barrier" button
          if(postText.indexOf("?au") >0){
            digitalWrite(pin3,HIGH);
            delay(1000);
            digitalWrite(pin3,LOW);
            Serial.println("Exit barrier up");
          }
          client.println(F("<div class=\"w3-content w3-padding\"><img src=\"http://www.bitsfromitaly.it/images/barrier.png\" onclick=\"location.href='http://192.168.1.13/?au'\"></div>"));
          client.println(F("</div>"));
          client.println(F("<div class=\"w3-half w3-blue w3-center w3-padding\">"));
          // User has set Exit to automatic mode1
          if(postText.indexOf("?atu") >0 ){
            digitalWrite(pin4,HIGH);
            Serial.println("Exit automatic mode");
            autoout = true;
          }
          // User has set Exit to access control
          if(postText.indexOf("?bau") >0 ){
            digitalWrite(pin4,LOW);
            Serial.println("Exit control access mode");
            autoout = false;
          }
          if (autoout == false)
            { client.println(F("<div class=\"w3-content w3-padding\"><img src=\"http://www.bitsfromitaly.it/images/automatic.png\" onclick=\"location.href='http://192.168.1.13/?atu'\"></div>")); }
            else
            { client.println(F("<div class=\"w3-content w3-padding\"><img src=\"http://www.bitsfromitaly.it/images/badge.png\" onclick=\"location.href='http://192.168.1.13/?bau'\"></div>")); }
          client.println(F("</div>"));
          client.println(F("</div>"));
          client.println(F("</div>"));
          client.println(F("</body>"));
          client.println(F("</html>"));
          break;
        }
        if (c == '\n') {
          currentLineIsBlank = true;
        }
        else if (c != '\r') {
          currentLineIsBlank = false;
        }
      }
    } 
    delay(1);
    // Let's close the connection
    client.stop();
    Serial.println("client disconnected");
  }
}
